﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class AutoCompleteExtender : Page
{
    private static Random random = new Random();
    private static List<string> strings = new List<string>();

    [WebMethod]
    public static string[] CompleteString(string prefixText, int count)
    {
        if (FindMatchedStringsCount(prefixText) == 0)
        {
            InitializeStrings(prefixText);
        }

        return FindMatchedStrings(prefixText, count).ToArray();
    }

    private static int FindMatchedStringsCount(string prefixText)
    {
        return FindMatchedStrings(prefixText).Count;
    }

    private static List<string> FindMatchedStrings(string prefixText, int count)
    {
        int i = 0;

        return FindMatchedStrings(prefixText).FindAll(
            delegate
            {
                return i < count;
            });
    }

    private static List<string> FindMatchedStrings(string prefixText)
    {
        return strings.FindAll(
            delegate(string s)
            {
                return s.StartsWith(prefixText);
            });
    }

    private static void InitializeStrings(string prefixText)
    {
        strings.Clear();

        for (int i = 0; i < 100; ++i)
        {
            string s = CreateRandomString(prefixText);

            if (!strings.Contains(s))
            {
                strings.Add(s);
            }
        }

        strings.Sort();
    }

    private static string CreateRandomString(string prefixText)
    {
        while (true)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(prefixText);

            for (int i = 0; i < random.Next(10); ++i)
            {
                sb.Append((char)('ぁ' + random.Next(84)));
            }

            return sb.ToString();
        }
    }
}
